lists.openwall.net   lists  /  announce  owl-users  owl-dev  john-users  john-dev  passwdqc-users  yescrypt  popa3d-users  /  oss-security  kernel-hardening  musl  sabotage  tlsify  passwords  /  crypt-dev  xvendor  /  Bugtraq  Full-Disclosure  linux-kernel  linux-netdev  linux-ext4  linux-hardening  linux-cve-announce  PHC 
Open Source and information security mailing list archives
 
Hash Suite: Windows password security audit tool. GUI, reports in PDF.
[<prev] [next>] [<thread-prev] [thread-next>] [day] [month] [year] [list]
Date:   Mon, 11 Jul 2022 22:56:31 +0200
From:   Jiri Olsa <olsajiri@...il.com>
To:     German Gomez <german.gomez@....com>
Cc:     linux-kernel@...r.kernel.org, linux-perf-users@...r.kernel.org,
        acme@...nel.org, irogers@...gle.com,
        Anshuman Khandual <anshuman.khandual@....com>,
        Mark Rutland <mark.rutland@....com>,
        Alexander Shishkin <alexander.shishkin@...ux.intel.com>,
        Namhyung Kim <namhyung@...nel.org>
Subject: Re: [PATCH v2 1/1] perf test: Add test for branch stack sampling

On Tue, Jul 05, 2022 at 04:05:11PM +0100, German Gomez wrote:
> Add a self test for branch stack sampling, to check that we get the
> expected branch types, and filters behave as expected.
> 
> Suggested-by: Anshuman Khandual <anshuman.khandual@....com>
> Signed-off-by: German Gomez <german.gomez@....com>

Tested-by: Jiri Olsa <jolsa@...nel.org>

thanks,
jirka

> ---
>  tools/perf/tests/shell/test_brstack.sh | 114 +++++++++++++++++++++++++
>  1 file changed, 114 insertions(+)
>  create mode 100755 tools/perf/tests/shell/test_brstack.sh
> 
> diff --git a/tools/perf/tests/shell/test_brstack.sh b/tools/perf/tests/shell/test_brstack.sh
> new file mode 100755
> index 000000000..5f6f40a77
> --- /dev/null
> +++ b/tools/perf/tests/shell/test_brstack.sh
> @@ -0,0 +1,114 @@
> +#!/bin/sh
> +# Check branch stack sampling
> +
> +# SPDX-License-Identifier: GPL-2.0
> +# German Gomez <german.gomez@....com>, 2022
> +
> +# we need a C compiler to build the test programs
> +# so bail if none is found
> +if ! [ -x "$(command -v cc)" ]; then
> +	echo "failed: no compiler, install gcc"
> +	exit 2
> +fi
> +
> +# skip the test if the hardware doesn't support branch stack sampling
> +perf record -b -o- -e dummy -B true > /dev/null 2>&1 || exit 2
> +
> +TMPDIR=$(mktemp -d /tmp/__perf_test.program.XXXXX)
> +
> +cleanup() {
> +	rm -rf $TMPDIR
> +}
> +
> +trap cleanup exit term int
> +
> +gen_test_program() {
> +	# generate test program
> +	cat << EOF > $1
> +#define BENCH_RUNS 999999
> +int cnt;
> +void bar(void) {
> +}			/* return */
> +void foo(void) {
> +	bar();		/* call */
> +}			/* return */
> +void bench(void) {
> +  void (*foo_ind)(void) = foo;
> +  if ((cnt++) % 3)	/* branch (cond) */
> +    foo();		/* call */
> +  bar();		/* call */
> +  foo_ind();		/* call (ind) */
> +}
> +int main(void)
> +{
> +  int cnt = 0;
> +  while (1) {
> +    if ((cnt++) > BENCH_RUNS)
> +      break;
> +    bench();		/* call */
> +  }			/* branch (uncond) */
> +  return 0;
> +}
> +EOF
> +}
> +
> +test_user_branches() {
> +	echo "Testing user branch stack sampling"
> +
> +	gen_test_program "$TEMPDIR/program.c"
> +	cc -fno-inline -g "$TEMPDIR/program.c" -o $TMPDIR/a.out
> +
> +	perf record -o $TMPDIR/perf.data --branch-filter any,save_type,u -- $TMPDIR/a.out > /dev/null 2>&1
> +	perf script -i $TMPDIR/perf.data --fields brstacksym | xargs -n1 > $TMPDIR/perf.script
> +
> +	# example of branch entries:
> +	# 	foo+0x14/bar+0x40/P/-/-/0/CALL
> +
> +	set -x
> +	egrep -m1 "^bench\+[^ ]*/foo\+[^ ]*/IND_CALL$"	$TMPDIR/perf.script
> +	egrep -m1 "^foo\+[^ ]*/bar\+[^ ]*/CALL$"	$TMPDIR/perf.script
> +	egrep -m1 "^bench\+[^ ]*/foo\+[^ ]*/CALL$"	$TMPDIR/perf.script
> +	egrep -m1 "^bench\+[^ ]*/bar\+[^ ]*/CALL$"	$TMPDIR/perf.script
> +	egrep -m1 "^bar\+[^ ]*/foo\+[^ ]*/RET$"		$TMPDIR/perf.script
> +	egrep -m1 "^foo\+[^ ]*/bench\+[^ ]*/RET$"	$TMPDIR/perf.script
> +	egrep -m1 "^bench\+[^ ]*/bench\+[^ ]*/COND$"	$TMPDIR/perf.script
> +	egrep -m1 "^main\+[^ ]*/main\+[^ ]*/UNCOND$"	$TMPDIR/perf.script
> +	set +x
> +
> +	# some branch types are still not being tested:
> +	# IND COND_CALL COND_RET SYSCALL SYSRET IRQ SERROR NO_TX
> +}
> +
> +# first argument <arg0> is the argument passed to "--branch-stack <arg0>,save_type,u"
> +# second argument are the expected branch types for the given filter
> +test_filter() {
> +	local filter=$1
> +	local expect=$2
> +
> +	echo "Testing branch stack filtering permutation ($filter,$expect)"
> +
> +	gen_test_program "$TEMPDIR/program.c"
> +	cc -fno-inline -g "$TEMPDIR/program.c" -o $TMPDIR/a.out
> +
> +	perf record -o $TMPDIR/perf.data --branch-filter $filter,save_type,u -- $TMPDIR/a.out > /dev/null 2>&1
> +	perf script -i $TMPDIR/perf.data --fields brstack | xargs -n1 > $TMPDIR/perf.script
> +
> +	# fail if we find any branch type that doesn't match any of the expected ones
> +	# also consider UNKNOWN branch types (-)
> +	if egrep -vm1 "^[^ ]*/($expect|-|( *))$" $TMPDIR/perf.script; then
> +		return 1
> +	fi
> +}
> +
> +set -e
> +
> +test_user_branches
> +
> +test_filter "any_call"	"CALL|IND_CALL|COND_CALL|SYSCALL|IRQ"
> +test_filter "call"	"CALL|SYSCALL"
> +test_filter "cond"	"COND"
> +test_filter "any_ret"	"RET|COND_RET|SYSRET|ERET"
> +
> +test_filter "call,cond"		"CALL|SYSCALL|COND"
> +test_filter "any_call,cond"		"CALL|IND_CALL|COND_CALL|IRQ|SYSCALL|COND"
> +test_filter "cond,any_call,any_ret"	"COND|CALL|IND_CALL|COND_CALL|SYSCALL|IRQ|RET|COND_RET|SYSRET|ERET"
> -- 
> 2.25.1
> 

Powered by blists - more mailing lists

Powered by Openwall GNU/*/Linux Powered by OpenVZ